(function () {
// Angular Directives

    var module = angular
        .module('thing-it.bim', []);

    module.directive("tiSvgFloorPlan", function () {
        return {
            restrict: 'A',
            controller: function ($scope) {
            },
            scope: true,
            compile: function compile(element, attrs, transclude) {
                return {
                    pre: function (scope, element, attrs, controller) {
                        var uuid = getUuid();

                        element.append('<div>' +
                            '<div id="ti-floorplan-coordinates' + uuid + '" class="fontSize0_8 marginTop0_5 marginBottom0_5">&nbsp;</div>' +
                            '<div class="flexLayout">' +
                            '<div class="flexGrow1">' +
                            '<div style="position: relative; width: 100%; height: 100%;">' +
                            '<div id="ti-floorplan' + uuid + '" style="position: absolute; top: 0; left: 0; width: 100%; height: 60vh;" ></div>' +
                            '</div>' +
                            '</div>' +
                            '<div id="ti-toolbar' + uuid + '" class="marginLeft0_5 flexLayout flexDirectionColumn flexAlignCenter">' +
                            '<a id="zoomIn"><i class="fontSize1_5 icon sl-zoom-in"></i></a>' +
                            '<a id="resetZoom"><i class="marginTop1 fontSize1_5 icon sl-loop-1"></i></a>' +
                            '<a id="zoomOut"><i class="marginTop1 fontSize1_5 fontSize1_5 icon sl-zoom-out"></i></a>' +
                            '<a id="meter"><i class="marginTop1 fontSize1_5 icon sl-italic"></i></a>' +
                            '<a id="space"><i class="marginTop1 fontSize1_5 icon sl-box-1"></i></a>' +
                            '<a id="polylineSpace"><i class="marginTop1 fontSize1_5 icon sl-magic-wand-2"></i></a>' +
                            '<a id="door"><i class="marginTop1 fontSize1_5 icon sl-door"></i></a>' +
                            '</div>' +
                            '</div>');

                        scope.editor = new FloorPlanEditor().initialize(element, uuid);

                        if (attrs.ngChange) {
                            scope.editor.onModelChange = function () {
                                scope
                                    .$eval(attrs.ngChange);
                            };
                        }

                        scope.elements = scope.editor.elements;

                        scope.editor.setMeteringListener(function (length) {
                            if (attrs.tiMeteringReference) {
                                scope.$eval(attrs.tiMeteringReference + '=' + length);
                            }

                            safeApply(scope);

                            if (attrs.tiMeteringEnd) {
                                scope.$eval(attrs.tiMeteringEnd);
                            }
                        });
                    },
                    post: function postLink(scope, element, attrs, controller) {
                        scope
                            .$watch(
                                attrs.ngModel,
                                function (model) {
                                    if (model) {
                                        scope.editor.setBuildingElement(model);
                                    }
                                });
                        scope
                            .$watch(
                                attrs.tiOptions,
                                function (options) {
                                    if (options) {
                                        scope.editor.setOptions(options);
                                    }
                                });
                        scope
                            .$watch(
                                attrs.tiOptions + '.width',
                                function (value) {
                                    if (value) {
                                        scope.floorPlanPanZoom.resize();
                                        scope.floorPlanPanZoom.fit();
                                    }
                                });
                        scope
                            .$watch(
                                attrs.tiOptions + '.height',
                                function (value) {
                                    if (value) {
                                        scope.floorPlanPanZoom.resize();
                                        scope.floorPlanPanZoom.fit();
                                    }
                                });
                        scope
                            .$watch(
                                attrs.tiOptions + '.showPredefinedFloorPlan',
                                function (value) {
                                    scope.editor.showPredefinedFloorPlan(value);
                                });
                        scope
                            .$watch(
                                attrs.tiOptions + '.showSpaces',
                                function (value) {
                                    scope.editor.showSpaces(value);
                                });
                        scope
                            .$watch(
                                attrs.tiOptions + '.showWalls',
                                function (value) {
                                    scope.editor.showWalls(value);
                                });
                        scope
                            .$watch(
                                attrs.tiOptions + '.showDoors',
                                function (value) {
                                    scope.editor.showDoors(value);
                                });
                        scope
                            .$watch(
                                attrs.tiOptions + '.showWindows',
                                function (value) {
                                    scope.editor.showWindows(value);
                                });
                        scope
                            .$watch(
                                attrs.tiOptions + '.showSlabs',
                                function (value) {
                                    scope.editor.showSlabs(value);
                                });
                        scope
                            .$watch(
                                attrs.tiOptions + '.showFlowTerminals',
                                function (value) {
                                    scope.editor.showFlowTerminals(value);
                                });
                        scope
                            .$watch(
                                attrs.ngModel + '.draft.scale',
                                function (value) {
                                    if (value) {
                                        scope.scale = Number(value);

                                        recalculateLegend();
                                    }
                                });
                        scope
                            .$watch(
                                attrs.ngModel + '.draft.xOrigin',
                                function (value) {
                                    if (value) {
                                        scope.xOrigin = Number(value);

                                        recalculateOrigin();
                                        recalculateLegend();
                                    }
                                });
                        scope
                            .$watch(
                                attrs.ngModel + '.draft.yOrigin',
                                function (value) {
                                    if (value) {
                                        scope.yOrigin = Number(value);

                                        recalculateOrigin();
                                        recalculateLegend();
                                    }
                                });
                        scope
                            .$watch(
                                attrs.tiCenter,
                                function (value) {
                                    if (value) {
                                        scope.editor.centerTo(value);
                                    }
                                });

                    }
                }
            },
            link: function (scope, element, attrs) {
            }
        };
    });

    function safeApply(scope) {
        var phase = scope.$root.$$phase;

        if (phase != '$apply' && phase != '$digest') {
            scope.$apply();
        }
    }

    module.directive("tiFloorPlan3d", function () {
        return {
            restrict: 'A',
            controller: function ($scope) {
            },
            scope: true,
            compile: function compile(element, attrs, transclude) {
                return {
                    pre: function (scope, element, attrs, controller) {
                        scope.bimViewer3d = new BimViewer3d().initialize(element);
                    },
                    post: function (scope, element, attrs, controller) {
                        scope
                            .$watch(
                                attrs.ngModel,
                                function (floor) {
                                    if (floor && floor.hasFloorplan()) {
                                        scope.bimViewer3d.setFloor(floor);
                                    }
                                });
                        scope
                            .$watch(
                                attrs.tiOptions,
                                function (options) {
                                    if (options) {
                                        scope.bimViewer3d.setOptions(options);
                                    }
                                });
                    }
                }
            }
        }
    });
    module.directive("tiNavigationPath", function () {
        return {
            restrict: 'A',
            //require: '^tiSvgFloorPlan',
            link: function (scope, element, attrs) {
                var renderer = new NavigationPathRenderer().initialize(scope.editor);

                scope.$eval(attrs.ngModel).addListener(renderer);
                // scope
                //     .$watch(
                //         attrs.tiOptions + '.colors',
                //         function (options) {
                //             renderer.setOptions(options);
                //         });
            }
        };
    });
    module.directive("tiNavigationAnimator3d", function () {
        return {
            restrict: 'A',
            //require: '^tiSvgFloorPlan',
            link: function (scope, element, attrs) {
                var animator = new NavigationAnimator3d().initialize(scope.bimViewer3d);

                scope.$eval(attrs.ngModel).addListener(animator);

                scope
                    .$watch(
                        attrs.tiOptions + '.colors',
                        function (options) {
                            if (options) {
                                animator.setOptions(options);
                            }
                        });
            }
        };
    });

// Functions

    function getUuid() {
        var lut = [];

        for (var i = 0; i < 256; i++) {
            lut[i] = (i < 16 ? '0' : '') + (i).toString(16);
        }

        var d0 = Math.random() * 0xffffffff | 0;
        var d1 = Math.random() * 0xffffffff | 0;
        var d2 = Math.random() * 0xffffffff | 0;
        var d3 = Math.random() * 0xffffffff | 0;

        return lut[d0 & 0xff] + lut[d0 >> 8 & 0xff] + lut[d0 >> 16 & 0xff] + lut[d0 >> 24 & 0xff] + '-' +
            lut[d1 & 0xff] + lut[d1 >> 8 & 0xff] + '-' + lut[d1 >> 16 & 0x0f | 0x40] + lut[d1 >> 24 & 0xff] + '-' +
            lut[d2 & 0x3f | 0x80] + lut[d2 >> 8 & 0xff] + '-' + lut[d2 >> 16 & 0xff] + lut[d2 >> 24 & 0xff] +
            lut[d3 & 0xff] + lut[d3 >> 8 & 0xff] + lut[d3 >> 16 & 0xff] + lut[d3 >> 24 & 0xff];
    }

// Classes

    function FloorPlanEditor() {
    }

    /**
     * Transforms browser page points to points of (the main/edit group of the) the floorplan SVG.
     *
     * @param point
     * @returns {{x: number, y: number}}
     */
    FloorPlanEditor.prototype.pageToGeoPoint = function (point) {
        var pageOffset = this.floorPlan.offset();
        var transform = this.mainGroup.transform();

        var x = Math.round(point.x - pageOffset.left - transform.x);
        var y = Math.round(point.y - pageOffset.top - transform.y);
        var zoom = 1;

        if (this.floorPlanPanZoom) {
            zoom = this.floorPlanPanZoom.getZoom();
        }

        return {x: x / zoom, y: y / zoom};
    };

    /**
     * Transforms floorplan SVG main/edit group points (all transformations applied) to world points in mm.
     *
     * @param point
     */
    FloorPlanEditor.prototype.drawingToWorldPosition = function (point) {
        var transform = this.mainGroup.transform();

        return {
            x: (point.x - transform.x) / this.floor._scale * 1000,
            y: (point.y - transform.y) / this.floor._scale * 1000
        };
    };

    /**
     * Transforms floorplan SVG main/edit group points (pan/zoom transformation not applied) to world points in mm.
     *
     * @param point
     */
    FloorPlanEditor.prototype.geoToWorldPoint = function (point) {
        return {
            x: point.x / this.floor._scale * 1000,
            y: point.y / this.floor._scale * 1000
        };
    };

    /**
     * Transforms floorplan SVG points to world points in mm.
     *
     * @param point
     */
    FloorPlanEditor.prototype.worldToGeoPoint = function (point) {
        return {x: point.x * this.floor._scale / 1000, y: point.y * this.floor._scale / 1000};
    };

    /**
     * Transforms floorplan SVG coordinates or distances to world coordinates or distances in mm
     *
     * @param point
     */
    FloorPlanEditor.prototype.geoToWorld = function (value) {
        return value / this.floor._scale * 1000;
    };

    /**
     * Transforms world coordinates or distances to floorplan coordinates or distances in mm
     *
     * @param point
     */
    FloorPlanEditor.prototype.worldToGeo = function (value) {
        return value * this.floor._scale / 1000;
    };

    FloorPlanEditor.prototype.initialize = function (element, uuid) {
        this.uuid = uuid;
        this.options = {showPredefinedFloorPlan: true};
        this.elements = [];
        this.renderers = [];
        this.toolbar = jQuery(element).find('#ti-toolbar' + uuid);
        this.floorPlan = jQuery(element).find('#ti-floorplan' + uuid);

        // Catch event propagation

        this.floorPlan.mousemove(function (event) {
            event.stopPropagation();
        });

        this.coordinates = jQuery(element).find('#ti-floorplan-coordinates' + uuid);

        this.dragging = false;

        // Bind Buttons

        this.zoomInButton = jQuery(element).find('#zoomIn');
        this.resetZoomButton = jQuery(element).find('#resetZoom');
        this.zoomOutButton = jQuery(element).find('#zoomOut');
        this.spaceButton = jQuery(element).find('#space');
        this.meterButton = jQuery(element).find('#meter');
        this.polylineSpaceButton = jQuery(element).find('#polylineSpace');
        this.doorButton = jQuery(element).find('#door');

        this.zoomInButton.hide();
        this.resetZoomButton.hide();
        this.zoomOutButton.hide();
        this.meterButton.hide();
        this.spaceButton.hide();
        this.polylineSpaceButton.hide();
        this.doorButton.hide();

        // Zoom

        this.zoomInButton.click(function () {
            this.floorPlanPanZoom.zoomIn()
        }.bind(this));
        this.resetZoomButton.click(function () {
            if (!this.floorPlanPanZoom) {
                return;
            }

            this.floorPlanPanZoom.updateBBox();
            this.floorPlanPanZoom.fit();
        }.bind(this));
        this.zoomOutButton.click(function () {
            this.floorPlanPanZoom.zoomOut()
        }.bind(this));

        // Scale Metering

        jQuery(element).find('#meter').click(function () {
            this.meter = this.overlayGroup.line(0, 0, 0, 0).attr({
                stroke: '#FF0000',
                'stroke-width': 0.5,
                'stroke-dasharray': '- ',
                'arrow-end': 'classic-wide-long'
            });
            this.meteringStarted = false;

            this.floorPlan.css('cursor', 'crosshair');
        }.bind(this));

        // Space definition

        this.spaceButton.click(function () {
            if (this.spaceShape) {
                this.spaceShape.remove();
            }

            this.newSpaceShape = this.editGroup.group();
            this.spaceShapeStarted = false;

            this.floorPlan.css('cursor', 'crosshair');
        }.bind(this));

        // Polyline Space definition

        this.polylineSpaceButton.click(function () {
            if (this.spaceShape) {
                this.spaceShape.remove();
            }

            this.newPolylineSpaceShape = this.editGroup.group();

            this.floorPlan.css('cursor', 'crosshair');
        }.bind(this));

        // Door definition

        this.doorButton.click(function () {
            this.newDoorShape = this.overlayGroup.group();

            this.floorPlan.css('cursor', 'crosshair');
        }.bind(this));

        this.floorPlan.click(function (event) {
            if (!this.ifcGroup) {
                return;
            }

            if (this.selectedShape) {
                this.selectedShape.selectize(false);

                this.selectedShape = null;
            }

            var position = this.pageToGeoPoint({x: event.pageX, y: event.pageY});

            if (this.meter) {
                if (this.meteringStarted) {
                    var length = Math.round(Math.sqrt(Math.pow(position.x - this.meter.data('xStart'), 2) + Math.pow(position.y - this.meter.data('yStart'), 2)));

                    this.meter.remove();

                    this.meter = null;
                    this.meteringStarted = false;

                    this.floorPlan.css('cursor', 'default');

                    if (this.meteringListener) {
                        this.meteringListener(length);
                    }
                } else {
                    this.meter.plot(position.x, position.y, position.x, position.y);
                    this.meter.data('xStart', position.x);
                    this.meter.data('yStart', position.y);

                    this.meteringStarted = true;
                }
            } else if (this.newSpaceShape) {
                if (this.spaceShapeStarted) {
                    this.spaceShape = this.newSpaceShape;
                    this.newSpaceShape = null;
                    this.spaceShapeStarted = false;

                    this.spaceShape.text(this.space.name).x(this.spaceShape.bbox().x + 0.5 * this.spaceShape.bbox().width).y(this.spaceShape.bbox().y + 0.5 * this.spaceShape.bbox().height).font({'anchor': 'middle'})

                    this.bindSpaceShape();

                    var boundingBox = this.spaceShape.tbox();
                    var origin = this.drawingToWorldPosition({x: boundingBox.x, y: boundingBox.y});

                    this.space.setRectangleRepresentation(origin.x,
                        origin.y, boundingBox.width / this.floor._scale * 1000, boundingBox.height / this.floor._scale * 1000);
                    this.onModelChange();
                    this.floorPlan.css('cursor', 'default');
                } else {
                    this.newSpaceShape.rect(0, 0).attr({
                        'stroke': '#801515', 'stroke-width': 0.1 * this.floor._scale,
                        'fill': 'none'
                    });
                    this.newSpaceShape.move(position.x, position.y);

                    this.spaceShapeStarted = true;
                }
            } else if (this.newPolylineSpaceShape) {
                if (!this.polylinePath) {
                    this.polylinePath = [[position.x, position.y]];
                    this.polyline = this.newPolylineSpaceShape.polyline(this.polylinePath).attr({
                        'stroke': '#801515', 'stroke-width': 0.1 * this.floor._scale,
                        'fill': 'none'
                    });
                } else {
                    this.polylinePath.push([position.x, position.y]);

                    this.polyline.plot(this.polylinePath);

                    if (Math.abs(this.polylinePath[this.polylinePath.length - 1][0] - this.polylinePath[0][0]) < 10 &&
                        Math.abs(this.polylinePath[this.polylinePath.length - 1][1] - this.polylinePath[0][1]) < 10) {

                        this.newPolylineSpaceShape.text(this.space.name).x(this.newPolylineSpaceShape.tbox().x + 0.5 * this.newPolylineSpaceShape.tbox().width)
                            .y(this.newPolylineSpaceShape.tbox().y + 0.5 * this.newPolylineSpaceShape.tbox().height - 5 /* Font Size? */).font({'anchor': 'middle'})

                        //this.bindSpaceShape();

                        var points = [];

                        for (var n in this.polylinePath) {
                            var point = this.geoToWorldPoint(new Vector(this.polylinePath[n][0], this.polylinePath[n][1]));
                            points.push(point);
                        }

                        console.log('Points >>> ', points);

                        this.space.setPolylineRepresentation(points);

                        console.log('Space >>> ', this.space);

                        this.onModelChange();
                        this.floorPlan.css('cursor', 'default');

                        this.polylinePath = null;
                        this.polyline = null;
                        this.newPolylineSpaceShape = null;
                    }
                }
            } else if (this.newDoorShape) {
                var matchResult = this.floor.getSpaceClosestToPosition(this.geoToWorldPoint(position));
                var doorPosition = this.worldToGeoPoint({x: matchResult.x, y: matchResult.y});
                var doorBaseLine = new Vector(matchResult.segment[1].x - matchResult.segment[0].x, matchResult.segment[1].y - matchResult.segment[0].y).unit().multiply(900);

                this.newDoorShape.line(0, 0, this.worldToGeo(doorBaseLine.x), this.worldToGeo(doorBaseLine.y)).attr({
                    'stroke': '#FF0000', 'stroke-width': this.worldToGeo(200)
                });
                //this.newDoorShape.line(0, 0, this.worldToGeo(750), this.worldToGeo(200)).attr({
                //    'stroke': '#FF0000', 'stroke-width': 0.1 * this.floor._scale
                //});

                this.newDoorShape.move(doorPosition.x, doorPosition.y);
                this.floorPlan.css('cursor', 'default');

                // Add door to IFC

                if (!matchResult.space.__doors) {
                    matchResult.space.__doors = [];
                }

                var door = this.floor.addDoor(matchResult.space.name + ' - Door ' + (matchResult.space.__doors.length + 1));
                var direction = doorBaseLine.unit();

                console.log('Direction >>>>', direction);

                door.setPointRepresentation(matchResult.x, matchResult.y, direction.x, direction.y);

                console.log('Door >>>>', door);
                console.log('Floor >>>>', this.floor);

                // Bind door to all adjacent spaces

                this.floor.bindDoorToSpaces(door, 500);

                this.onModelChange();

                this.bindDoorShape(door, this.newDoorShape);

                this.newDoorShape = null;
            }
        }.bind(this));
        this.floorPlan.mousemove(function (event) {
            if (!this.editGroup) {
                return;
            }

            var geoPoint = this.pageToGeoPoint({x: event.pageX, y: event.pageY});
            var worldPosition = this.geoToWorldPoint(geoPoint);

            this.coordinates.empty();
            this.coordinates.append('[' + (worldPosition.x / 1000).toFixed(2) + ', ' + (worldPosition.y / 1000).toFixed(2) + ']');

            if (this.meter && this.meteringStarted) {
                this.meter.plot(this.meter.x(), this.meter.y(), geoPoint.x, geoPoint.y);
            }
            else if (this.newSpaceShape && this.spaceShapeStarted) {
                this.newSpaceShape.select('rect').width(Math.max(0, geoPoint.x - this.newSpaceShape.x()));
                this.newSpaceShape.select('rect').height(Math.max(0, geoPoint.y - this.newSpaceShape.y()));
            }
        }.bind(this));

        return this;
    };

    /**
     *
     * @param show
     */
    FloorPlanEditor.prototype.showPredefinedFloorPlan = function (show) {
        if (!this.predefinedGroup) {
            return;
        }

        if (show) {
            this.predefinedGroup.show();
        } else {
            this.predefinedGroup.hide();
        }
    };

    /**
     *
     * @param show
     */
    FloorPlanEditor.prototype.showSpaces = function (show) {
        if (show) {
            this.floorPlan.find('.ifcSpace').show();
        } else {
            this.floorPlan.find('.ifcSpace').hide();
        }
    };

    /**
     *
     * @param show
     */
    FloorPlanEditor.prototype.showWalls = function (show) {
        if (show) {
            this.floorPlan.find('.ifcWalls').show();
            this.floorPlan.find('.ifcWallStandardCase').show();

        } else {
            this.floorPlan.find('.ifcWalls').hide();
            this.floorPlan.find('.ifcWallStandardCase').hide();
        }
    };

    /**
     *
     * @param show
     */
    FloorPlanEditor.prototype.showDoors = function (show) {
        if (show) {
            this.floorPlan.find('.ifcDoor').show();

        } else {
            this.floorPlan.find('.ifcDoor').hide();
        }
    };

    /**
     *
     * @param show
     */
    FloorPlanEditor.prototype.showWindows = function (show) {
        if (show) {
            this.floorPlan.find('.ifcWindow').show();

        } else {
            this.floorPlan.find('.ifcWindow').hide();
        }
    };

    /**
     *
     * @param show
     */
    FloorPlanEditor.prototype.showSlabs = function (show) {
        if (show) {
            this.floorPlan.find('.ifcSlab').show();

        } else {
            this.floorPlan.find('.ifcSlab').hide();
        }
    };

    /**
     *
     * @param show
     */
    FloorPlanEditor.prototype.showFlowTerminals = function (show) {
        if (show) {
            this.floorPlan.find('.ifcFlowTerminal').show();

        } else {
            this.floorPlan.find('.ifcFlowTerminal').hide();
        }
    };

    /**
     *
     * @param listener
     */
    FloorPlanEditor.prototype.setMeteringListener = function (listener) {
        this.meteringListener = listener;
    };

    /**
     *
     * @param listener
     */
    FloorPlanEditor.prototype.setSpaceDefinitionListener = function (listener) {
        this.spaceShapeDefinitionListener = listener;
    };

    /**
     *
     * @param buildingElement
     */
    FloorPlanEditor.prototype.setBuildingElement = function (buildingElement) {
        if (buildingElement.type == 'IFCBUILDINGSTOREY') {
            this.floor = buildingElement;
        }
        else if (buildingElement.type == 'IFCSPACE') {
            this.space = buildingElement;
            this.floor = buildingElement.__floor;
        }

        if (!this.floor._scale) {
            this.floor._scale = 30; // Pixel/m
        }

        this.initializeGraphics().done(function () {
            if (this.space) {
                this.initializeSpace();
            }

            this.state = 'initialized';

            // Apply options

            this.setOptions(this.options);
        }.bind(this));
    };

    /**
     *
     */
    FloorPlanEditor.prototype.initializeSpace = function () {
        if (this.spaceShape) {
            this.spaceShape.remove();
        }

        // Bind Space representation

        if (this.floor.floorPlanSvgFileUri/*this.floor.hasPredefinedFloorplan()*/) {
            this.spaceButton.show();
            this.polylineSpaceButton.show();

            if (this.space.representation) {
                this.spaceShape = SVG.get(this.space.id);

                this.bindSpaceShape();
            }
        }
    };

    /**
     *
     * @param options
     */
    FloorPlanEditor.prototype.setOptions = function (options) {
        this.options = options;

        if (this.state != 'initialized') {
            return;
        }

        if (options.showToolbar != undefined && options.showToolbar == false) {
            this.toolbar.hide();
        } else {
            this.toolbar.show();
        }

        if (options.showBorder != undefined && options.showBorder == false && this.overlay) {
            this.overlay.removeClass('defaultBorder');
        }

        if ((options.showButtons != undefined && options.showButtons == false) || (options.showZoomInButton != undefined && options.showZoomInButton == false)) {
            this.zoomInButton.hide();
        } else {
            this.zoomInButton.show();
        }

        if ((options.showButtons != undefined && options.showButtons == false) || (options.showResetZoomButton != undefined && options.showResetZoomButton == false)) {
            this.resetZoomButton.hide();
        } else {
            this.resetZoomButton.show();
        }

        if ((options.showButtons != undefined && options.showButtons == false) || (options.showZoomOutButton != undefined && options.showZoomOutButton == false)) {
            this.zoomOutButton.hide();
        } else {
            this.zoomOutButton.show();
        }

        if ((options.showButtons != undefined && options.showButtons == false) || (options.showMeterButton != undefined && options.showMeterButton == false)) {
            this.meterButton.hide();
        } else {
            this.meterButton.show();
        }

        if ((options.showButtons != undefined && options.showButtons == false) || (options.showSpaceButton != undefined && options.showSpaceButton == false)) {
            this.spaceButton.hide();
        } else {
            this.spaceButton.show();
        }

        if ((options.showButtons != undefined && options.showButtons == false) || (options.showPolylineSpaceButton != undefined && options.showPolylineSpaceButton == false)) {
            this.polylineSpaceButton.hide();
        } else {
            this.polylineSpaceButton.show();
        }

        if ((options.showButtons != undefined && options.showButtons == false) || (options.showDoorButton != undefined && options.showDoorButton == false)) {
            this.doorButton.hide();
        } else {
            this.doorButton.show();
        }

        if ((options.showOrigin != undefined && options.showOrigin == false)) {
            if (this.originShape) {
                this.originShape.hide();
            }
        } else {
            if (this.originShape) {
                this.originShape.show();
            }
        }

        if ((options.showScale != undefined && options.showScale == false)) {
            this.scaleGroup.hide();
        } else {
            this.scaleGroup.show();
        }

        if ((options.showCoordinates != undefined && options.showCoordinates == false)) {
            this.coordinates.hide();
        } else {
            this.coordinates.show();
        }
    };

    /**
     *
     */
    FloorPlanEditor.prototype.initializeGraphics = function () {
        var deferred = jQuery.Deferred();

        this.xOffset = 0;
        this.yOffset = 0;

        // Cleanup Floor Plan

        //if (scope.floorPlanPanZoom) {
        //    scope.floorPlanPanZoom.destroy();
        //}

        this.floorPlan.empty();

        this.mainSvg = SVG('ti-floorplan' + this.uuid);

        this.mainSvgId = 'ti-floorplan-svg' + this.uuid;

        this.mainSvg.attr('id', this.mainSvgId);

        this.mainGroup = this.mainSvg.group();

        this.mainGroup.attr('id', 'ti-main-group');

        this.predefinedGroup = this.mainGroup.group().attr('id', 'ti-predefined-group');
        this.ifcGroup = this.mainGroup.group().attr('id', 'ti-ifc-group');
        this.rendererGroup = this.mainGroup.group().attr('id', 'ti-renderer-group');
        this.overlayGroup = this.mainGroup.group().attr('id', 'ti-overlay-group');
        this.editGroup = this.mainGroup.group().attr('id', 'ti-edit-group');

        var loadDeferred = jQuery.Deferred();

        this.predefinedFloorPlan = null;

        if (this.floor.floorPlanSvgFileUri) {
            this.predefinedFloorPlan = this.predefinedGroup.image(this.floor.floorPlanSvgFileUri).loaded(function () {
                this.predefinedFloorPlan.opacity(0.5);

                this.ifcGroup.scale(this.floor._scale / 1000);
                this.rendererGroup.scale(this.floor._scale / 1000);
                loadDeferred.resolve();
            }.bind(this));
        } else {
            loadDeferred.resolve();
        }

        //this.floorPlanSvg = this.floorPlan.find('svg');
        //
        //this.floorPlanSvg.prop('id', this.floorPlanSvgId);
        //
        //// Initialize scale from SVG
        //
        //if (this.floor._scale == undefined) {
        //    if (this.floor.floorPlanSvgFileUri) {
        //        var viewBox = this.floorPlanSvg.prop('viewBox');
        //        var width = this.floorPlanSvg.prop('width');
        //        var height = this.floorPlanSvg.prop('height');
        //
        //        // TODO Other representations
        //
        //        if (width && width.baseVal && width.baseVal.value) {
        //            this.floor._scale = width.baseVal.value / 20; // Assuming that the average draft is 30 meters ...
        //        } else {
        //            this.floor._scale = 1000;
        //        }
        //
        //        // Save adjustments on scale
        //        // TODO tiEndMetering?
        //
        //        //if (attrs.ngChange) {
        //        //    scope
        //        //        .$eval(attrs.ngChange);
        //        //}
        //    } else {
        //        this.floor._scale = 1000;
        //    }
        //}
        //
        //this.overlaySvg = SVG(this.floorPlanSvgId);
        //this.overlaySvgGroup = this.overlaySvg.group();
        //this.editGroup = this.overlaySvg.group();

        // If predefined SVG/image has a different pixel/m than the IFC model (1000 pixel/m), IFC data have to be transformed for rendering

        //if (this.floor._scale) {
        //    this.overlaySvgGroup.transform({scaleX: this.floor._scale / 1000, scaleY: this.floor._scale / 1000});
        //}

        loadDeferred.promise().done(function () {
            // Apply resulting aspect ration for SVG to the DOM container

            this.floorPlan.height(this.floorPlan.width() * this.mainGroup.bbox().height / this.mainGroup.bbox().width);

            var canvas = this.floorPlan.find('canvas')[0];

            if (canvas) {
                canvas.height = this.floorPlan.height();
                canvas.width = this.floorPlan.width();
            }

            // Add floorplan contributions from IFC Model

            this.floor.renderFloorPlanSvg(this.ifcGroup, {scale: this.floor._scale});

            // Bind all child elements

            for (var n in this.renderers) {
                this.renderers[n].parent = this.rendererGroup;
                this.renderers[n].render();
            }

            this.xOffset = this.ifcGroup.bbox().x;
            this.yOffset = this.ifcGroup.bbox().y;

            if (this.predefinedFloorPlan) {
                this.drawScale();
                this.drawOrigin();
                //this.mainGroup.viewbox(0, 0, this.floorPlan.width(), this.floorPlan.height());
            } else {
                //var box = this.floor.getBoundingBox();
                //
                //this.mainGroup.viewbox(box.x, box.y, box.width, box.height);
            }

            this.mainGroup.addClass('svg-pan-zoom_viewport');

            if (!this.options.noPanZoom) {
                var eventsHandler;

                if (!Hammer) {
                    window.alert('No Hammer');

                    eventsHandler = null;
                } else {
                    eventsHandler = {
                        haltEventListeners: ['touchstart', 'touchend', 'touchmove', 'touchleave', 'touchcancel'],
                        init: function (options) {
                            var instance = options.instance;
                            var initialScale = 1;
                            var pannedX = 0;
                            var pannedY = 0;

                            // Init Hammer
                            // Listen only for pointer and touch events

                            this.hammer = Hammer(options.svgElement, {
                                inputClass: Hammer.SUPPORT_POINTER_EVENTS ? Hammer.PointerEventInput : Hammer.TouchInput
                            });

                            // Enable pinch

                            this.hammer.get('pinch').set({enable: true})

                            // Handle double tap

                            this.hammer.on('doubletap', function (ev) {
                                instance.center();
                                instance.fit();
                            });

                            // Handle pan

                            this.hammer.on('panstart panmove', function (ev) {
                                // On pan start reset panned variables
                                if (ev.type === 'panstart') {
                                    pannedX = 0
                                    pannedY = 0
                                }

                                // Pan only the difference

                                instance.panBy({x: ev.deltaX - pannedX, y: ev.deltaY - pannedY});

                                pannedX = ev.deltaX;
                                pannedY = ev.deltaY;

                                ev.preventDefault();
                            });

                            // Handle pinch

                            this.hammer.on('pinchstart pinchmove', function (ev) {
                                // On pinch start remember initial zoom

                                if (ev.type === 'pinchstart') {
                                    initialScale = instance.getZoom()
                                    instance.zoom(initialScale * ev.scale)
                                }

                                instance.zoom(initialScale * ev.scale)
                            });

                            // Prevent moving the page on some devices when panning over SVG

                            options.svgElement.addEventListener('touchmove', function (e) {
                                e.preventDefault();
                            });
                        },
                        destroy: function () {
                            this.hammer.destroy()
                        }
                    }
                }

                this.floorPlanPanZoom = svgPanZoom('#' + this.mainSvgId, {
                    zoomEnabled: true,
                    fit: !this.predefinedFloorPlan,
                    controlIconsEnabled: false,
                    beforeZoom: function () {
                        return !this.dragging;
                    }.bind(this),
                    beforePan: function () {
                        return !this.dragging;
                    }.bind(this),
                    preventMouseEventsDefault: true,
                    customEventsHandler: eventsHandler
                });

                // this.floorPlanPanZoom.resize();
                // this.floorPlanPanZoom.fit();
            }

            deferred.resolve();
        }.bind(this));

        return deferred.promise();
    };

    /**
     *
     */
    FloorPlanEditor.prototype.getZoom = function () {
        if (this.floorPlanPanZoom) {
            return this.floorPlanPanZoom.getZoom();
        } else {
            return 1;
        }
    };

    /**
     *
     */
    FloorPlanEditor.prototype.getPan = function () {
        if (this.floorPlanPanZoom) {
            return this.floorPlanPanZoom.getPan();
        } else {
            return {x: 0, y: 0};
        }
    };

    /**
     *
     */
    FloorPlanEditor.prototype.addRenderer = function (renderer) {
        this.renderers.push(renderer);

        renderer.editor = this;
        renderer.parent = this.rendererGroup;
    };

    /**
     *
     */
    FloorPlanEditor.prototype.drawOrigin = function () {
        if (this.originShape) {
            this.originShape.remove();
        }

        this.originShape = this.overlayGroup.group().attr({
            stroke: '#245797',
            'stroke-width': 0.5
        });

        this.originShape.polyline('-' + 0.3 * this.floor._scale + ',-' + 0.3 * this.floor._scale + ' ' + 0.3 * this.floor._scale + ',' + 0.3 * this.floor._scale);
        this.originShape.polyline('-' + 0.3 * this.floor._scale + ',' + 0.3 * this.floor._scale + ' ' + 0.3 * this.floor._scale + ',-' + 0.3 * this.floor._scale);

        var editor = this;

        this.originShape.mouseover(function (event) {
            event.preventDefault();

            this.style('cursor', 'hand');
        }).mouseout(function (event) {
            event.preventDefault();

            this.style('cursor', 'default');
        }).draggable().on('dragstart', function (event) {
            event.preventDefault();

            editor.dragging = true;
        }).on('dragend', function (event) {
            event.preventDefault();

            editor.dragging = false;
        });
    };

    /**
     *
     */
    FloorPlanEditor.prototype.bindSpaceShape = function () {
        var editor = this;

        // TODO More sophisticated ...

        this.spaceShape.select('rect').attr('stroke', 'red');
        this.spaceShape.select('text').attr('fill', 'red');
        this.spaceShape.select('polyline').attr('stroke', 'red');

        this.spaceShape.mouseover(function (event) {
            event.preventDefault();

            this.select('rect').attr('stroke-width', 0.15 * editor.floor._scale);
            this.style('cursor', 'hand');
        }).mouseout(function (event) {
            event.preventDefault();

            this.select('rect').attr('stroke-width', 0.1 * editor.floor._scale);
            this.style('cursor', 'default');
        }).draggable().on('dragstart', function (event) {
            event.preventDefault();

            editor.dragging = true;
        }).on('dragend', function (event) {
            event.preventDefault();

            editor.dragging = false;

            var boundingBox = this.bbox();

            this.space.setRectangleRepresentation(boundingBox.x / this.floor._scale * 1000,
                boundingBox.y / this.floor._scale * 1000, boundingBox.width / this.floor._scale * 1000, boundingBox.height / this.floor._scale * 1000);
            editor.onModelChange();
        }).on('click', function () {
            event.preventDefault();

            editor.selectedShape = this;

            this.selectize();
        }).on('resizing', function () {
            event.preventDefault();

            editor.dragging = true;
        }).on('resizedone', function () {
            event.preventDefault();

            editor.dragging = false;

            var boundingBox = this.bbox();

            this.space.setRectangleRepresentation(boundingBox.x / this.floor._scale * 1000,
                boundingBox.y / this.floor._scale * 1000, boundingBox.width / this.floor._scale * 1000, boundingBox.height / this.floor._scale * 1000);
            editor.onModelChange();
        }).front();
    };

    FloorPlanEditor.prototype.bindDoorShape = function (door, doorShape) {
        var editor = this;

        doorShape.mouseover(function (event) {
            event.preventDefault();
            this.style('cursor', 'hand');
        }).mouseout(function (event) {
            event.preventDefault();
            this.style('cursor', 'default');
        }).draggable().on('dragstart', function (event) {
            event.preventDefault();

            editor.dragging = true;
        }).on('dragend', function (event) {
            event.preventDefault();

            editor.dragging = false;

            var boundingBox = doorShape.tbox();
            var matchResult = editor.floor.getSpaceClosestToPosition(editor.geoToWorldPoint(new Vector(boundingBox.x, boundingBox.y)));
            var doorPosition = editor.worldToGeoPoint({x: matchResult.x, y: matchResult.y});
            var doorBaseLine = new Vector(matchResult.segment[1].x - matchResult.segment[0].x, matchResult.segment[1].y - matchResult.segment[0].y).unit().multiply(900);

            doorShape.move(doorPosition.x, doorPosition.y);
            door.setPointRepresentation(matchResult.x, matchResult.y);
        }).on('click', function () {
            event.preventDefault();

            editor.selectedShape = this;

            this.selectize();
        }).front();
    };

    FloorPlanEditor.prototype.drawScale = function () {
        if (this.scaleGroup) {
            this.scaleGroup.remove();
        }

        this.scaleGroup = this.overlayGroup.group();

        var color = '#245797';
        var legendOffsetX = 10;
        var legendOffsetY = 30;
        var ticksCount = 5;

        var background = this.overlayGroup.rect(ticksCount * this.floor._scale, 40).attr({
            stroke: null,
            fill: '#FFFFFF',
            opacity: 0.3
        });

        background.move(legendOffsetX, legendOffsetY - 25);
        this.scaleGroup.add(background);

        var path = this.overlayGroup.line(legendOffsetX, legendOffsetY, legendOffsetX + (ticksCount - 0.5) * this.floor._scale, legendOffsetY).attr({
            stroke: color,
            'stroke-width': 0.5,
            'arrow-end': 'classic-wide-long'
        });

        path.front();

        this.scaleGroup.add(path);

        var tick;

        for (var n = 0; n < ticksCount; ++n) {
            this.scaleGroup.add(tick = this.overlayGroup.line(legendOffsetX + n * this.floor._scale, legendOffsetY - 3, legendOffsetX + n * this.floor._scale, legendOffsetY + 3).attr({
                stroke: color,
                'stroke-width': 0.5
            }));

            tick.front();
        }

        var text;

        for (var n = 1; n < ticksCount; ++n) {
            this.scaleGroup.add(text = this.overlayGroup.text('' + n + 'm').attr({
                text: '' + n + 'm',
                fill: color
            }));

            text.font({anchor: 'middle'});
            text.move(legendOffsetX + n * this.floor._scale, legendOffsetY - 20);
            text.front();
        }
    };

    FloorPlanEditor.prototype.centerTo = function (location) {
        if (!this.floorPlanPanZoom) {
            return;
        }

        var xPosition = this.worldToGeo(location.xPosition);
        var yPosition = this.worldToGeo(location.yPosition);

        // var viewBox = this.viewport.getViewBox()
        //     , offsetX = (this.width - (viewBox.width + viewBox.x * 2) * this.getZoom()) * 0.5
        //     , offsetY = (this.height - (viewBox.height + viewBox.y * 2) * this.getZoom()) * 0.5
        // this.floorPlanPanZoom.pan({x: 0, y: 0});
        //
        // var realZoom = this.floorPlanPanZoom.getSizes().realZoom;
        //
        // xPosition = -(xPosition * realZoom) + (this.floorPlanPanZoom.getSizes().width / 2);
        // yPosition = -(yPosition * realZoom) + (this.floorPlanPanZoom.getSizes().height / 2);
        //
        // window.alert('Pixel: ' + xPosition + ' ' + yPosition);
        //

        this.floorPlanPanZoom.resetZoom();

        this.floorPlanPanZoom.pan
        ({
            x: xPosition,// - 0.5 * this.floorPlanPanZoom.getSizes().width,
            y: yPosition// - 0.5 * this.floorPlanPanZoom.getSizes().height
        });

        this.floorPlanPanZoom.zoom(5);
    };

    /**
     *
     * @constructor
     */
    function BimViewer3d() {
    };

    /**
     *
     * @param element
     */
    BimViewer3d.prototype.initialize = function (element) {
        element = jQuery(element);

        element.append('<div style="position: relative; width: 100%; min-height: 60vh;"><div id="ThreeJS" style="position: absolute; left:0px; top:0px"></div></div>');

        //this.keyboard = new THREEx.KeyboardState();
        this.container = document.getElementById('ThreeJS');

        // Renderer

        this.renderer = new THREE.WebGLRenderer({antialias: true});

        this.renderer.setSize(element.width(), element.height());
        this.container.appendChild(this.renderer.domElement);

        // Scene

        this.scene = new THREE.Scene();

        this.scene.background = new THREE.Color(0xFFFFFF);

        return this;
    };

    /**
     *
     */
    BimViewer3d.prototype.animate = function () {
        requestAnimationFrame(function () {
            this.animate();
        }.bind(this));
        this.render();
        this.update();
        TWEEN.update();
    };

    /**
     *
     */
    BimViewer3d.prototype.render = function () {
        this.renderer.render(this.scene, this.camera);
    };

    /**
     *
     */
    BimViewer3d.prototype.update = function () {
        //if (this.keyboard.pressed("z")) {
        //    // do something
        //}

        this.controls.update();
    };

    /**
     *
     * @param floor
     */
    BimViewer3d.prototype.setFloor = function (floor) {
        this.floor = floor;

        console.log('Floor >>>', this.floor);

        if (this.floor.hasFloorplan()) {
            // Calculate viewport

            this.viewBox = this.floor.getBoundingBox();
            this.gridSize = Math.max(this.viewBox.right - this.viewBox.left, this.viewBox.bottom - this.viewBox.top);

            // Camera

            var VIEW_ANGLE = 45;
            var ASPECT = 19 / 9;
            var NEAR = 0.1;
            var FAR = 100000;

            this.camera = new THREE.PerspectiveCamera(VIEW_ANGLE, ASPECT, NEAR, FAR);

            this.scene.add(this.camera);
            //this.camera.position.set(Math.round(0.5 * (this.viewBox.right + this.viewBox.left)), 4000, Math.round(0.5 * (this.viewBox.bottom + this.viewBox.top)));
            this.camera.position.set(0, 8000, 0);
            //this.camera.lookAt({
            //    x: 5000,
            //    y: 0,
            //    z: 5000
            //});

            // Events

            //THREEx.WindowResize(this.renderer, this.camera);
            //THREEx.FullScreen.bindKey({charCode: 'm'.charCodeAt(0)});

            // Controls

            this.controls = new THREE.OrbitControls(this.camera, this.renderer.domElement);

            this.controls.center.set(0.5 * (this.viewBox.right + this.viewBox.left), 4000, 0.5 * (this.viewBox.bottom + this.viewBox.top));

            // Light

            this.light = new THREE.PointLight(0xffffff);

            this.light.position.set(Math.round(0.5 * (this.viewBox.right + this.viewBox.left)), 4000, Math.round(0.5 * (this.viewBox.bottom + this.viewBox.top)));
            this.scene.add(this.light);

            // Floor

            //var floorTexture = new THREE.ImageUtils.loadTexture('./css/images/checkerboard.jpg');
            //
            //floorTexture.wrapS = floorTexture.wrapT = THREE.RepeatWrapping;
            //floorTexture.repeat.set(10, 10);
            //
            //var floorMaterial = new THREE.MeshBasicMaterial({map: floorTexture, side: THREE.DoubleSide});
            //var floorMesh = new THREE.Mesh(new THREE.PlaneGeometry(viewBox.right - viewBox.left, viewBox.bottom + viewBox.top), floorMaterial);
            //
            //floorMesh.position.x = viewBox.left;
            //floorMesh.position.y = 0;
            //floorMesh.rotation.x = Math.PI / 2;
            //
            //scene.add(floorMesh);

            // Skybox

            //var skyBoxGeometry = new THREE.CubeGeometry(viewBox.right - viewBox.left, viewBox.bottom + viewBox.top, viewBox.bottom + viewBox.top);
            //var skyBoxMaterial = new THREE.MeshBasicMaterial({color: 0x9999ff, side: THREE.BackSide});
            //var skyBox = new THREE.Mesh(skyBoxGeometry, skyBoxMaterial);
            //
            //scene.add(skyBox);

            for (var n in this.floor.__spaces) {
                this.renderSpace(this.floor.__spaces[n], this.floor.__walls.length == 0);
            }

            for (var n in this.floor.__walls) {
                this.renderWall(this.floor.__walls[n]);
            }

            for (var n in this.floor.__doors) {
                this.renderDoor(this.floor.__doors[n])
            }


            this.renderAxisHelper();
            //this.renderCameraReferencePoint();

            //var gridStep = 10;
            //
            //var gridXZ = new THREE.GridHelper(gridSize, gridStep);
            //
            //gridXZ.setColors(new THREE.Color(0x006600), new THREE.Color(0x006600));
            //
            //gridXZ.position.set(gridSize, 0, gridSize);
            //scene.add(gridXZ);
            //
            //var gridXY = new THREE.GridHelper(gridSize, gridStep);
            //
            //gridXY.position.set(gridSize, gridSize, 0);
            //
            //gridXY.rotation.x = Math.PI / 2;
            //
            //gridXY.setColors(new THREE.Color(0x000066), new THREE.Color(0x000066));
            //scene.add(gridXY);
            //
            //var gridYZ = new THREE.GridHelper(gridSize, gridStep);
            //
            //gridYZ.position.set(0, gridSize, gridSize);
            //
            //gridYZ.rotation.z = Math.PI / 2;
            //
            //gridYZ.setColors(new THREE.Color(0x660000), new THREE.Color(0x660000));
            //
            //scene.add(gridYZ);

            this.animate();
        }
    };

    /**
     *
     * @param options
     */
    BimViewer3d.prototype.renderCameraReferencePoint = function () {
        if (!this.cameraPositionPoint) {
            var geometry = new THREE.SphereGeometry(100, 32, 32);
            var material = new THREE.MeshLambertMaterial({color: 0xFF0000});

            this.cameraPositionPoint = new THREE.Mesh(geometry, material);

            //this.scene.add(this.cameraPositionPoint);
        }

        this.cameraPositionPoint.position.set(this.camera.position.x,
            this.camera.position.y,
            this.camera.position.z);

        if (!this.lookAtPositionPoint) {
            geometry = new THREE.SphereGeometry(100, 32, 32);
            material = new THREE.MeshLambertMaterial({color: 0x00FF00});

            this.lookAtPositionPoint = new THREE.Mesh(geometry, material);

            this.scene.add(this.lookAtPositionPoint);
        }

        var lookAt = this.controls.center;

        this.lookAtPositionPoint.position.set(lookAt.x,
            lookAt.y,
            lookAt.z);
    };

    /**
     *
     * @param options
     */
    BimViewer3d.prototype.renderAxisHelper = function () {
        this.axes = new THREE.AxisHelper(this.gridSize);

        this.axes.position = {x: 0, y: 0, z: 0};

        this.scene.add(this.axes);
    };

    /**
     *
     * @param options
     */
    BimViewer3d.prototype.renderSpace = function (space, extrude) {
        var geo = space.getGeo();

        if (geo.height == undefined && geo.points == undefined) {
            return;
        }

        if (extrude) {
            var points;

            if (geo.points) {
                points = geo.points;
            } else {
                points = [{x: geo.x, y: geo.y},
                    {x: geo.x + geo.width, y: geo.y},
                    {x: geo.x + geo.width, y: geo.y + geo.height},
                    {x: geo.x, y: geo.y + geo.height},
                    {x: geo.x, y: geo.y}];
            }

            var shape = new THREE.Shape();

            shape.moveTo(points[0].x, points[0].y);

            for (var n = 1; n < points.length; n++) {
                shape.lineTo(points[n].x, points[n].y);
            }

            var extruded = new THREE.ExtrudeGeometry(shape, {amount: -2700});
            var darkMaterial = new THREE.MeshLambertMaterial({
                color: 0xffdddd,
                transparent: true,
                opacity: 0.3
            });

            var mesh = new THREE.Mesh(extruded, darkMaterial);

            mesh.rotation.x = Math.PI / 2;

            this.scene.add(mesh);

        } else {
            var lineGeometry = new THREE.Geometry();
            var vertices = lineGeometry.vertices;

            if (geo.points) {
                for (var n = 0; n < geo.points.length - 1; n++) {
                    vertices.push(new THREE.Vector3(geo.points[n].x, 0, geo.points[n].y), new THREE.Vector3(geo.points[n + 1].x, 0, geo.points[n + 1].y));
                }
            } else {
                vertices.push(new THREE.Vector3(geo.x, 0, geo.y), new THREE.Vector3(geo.x + geo.width, 0, geo.y));
                vertices.push(new THREE.Vector3(geo.x + geo.width, 0, geo.y), new THREE.Vector3(geo.x + geo.width, 0, geo.y + geo.height));
                vertices.push(new THREE.Vector3(geo.x + geo.width, 0, geo.y + geo.height), new THREE.Vector3(geo.x, 0, geo.y + geo.height));
                vertices.push(new THREE.Vector3(geo.x, 0, geo.y + geo.height), new THREE.Vector3(geo.x, 0, geo.y));
            }

            lineGeometry.computeLineDistances();

            var lineMaterial = new THREE.LineBasicMaterial({color: 0x00CC00});
            var line = new THREE.Line(lineGeometry, lineMaterial);

            this.scene.add(line);
        }
    };

    /**
     *
     * @param options
     */
    BimViewer3d.prototype.renderDoor = function (door) {
        var width = 200;

        geo = door.getGeo();

        var shape = new THREE.Shape();

        // TODO Just assuming 2 points

        var x1;
        var y1;
        var x2;
        var y2;

        if (!geo.points) {
            x1 = geo.x;
            y1 = geo.y;
            x2 = geo.x + 900;
            y2 = geo.y;

        }
        else if (geo.points.length == 2) {
            x1 = geo.points[0].x;
            y1 = geo.points[0].y;
            x2 = geo.points[1].x;
            y2 = geo.points[1].y;
        } else {
            return;
        }

        var norm = Math.sqrt(Math.pow(x2 - x1, 2) + Math.pow(y2 - y1, 2));
        var xE = (y2 - y1) / norm;
        var yE = (x1 - x2) / norm;
        var halfWidth = 0.5 * width;

        shape.moveTo(x1 - halfWidth * xE, y1 - halfWidth * yE);
        shape.lineTo(x2 - halfWidth * xE, y2 - halfWidth * yE);
        shape.lineTo(x2 + halfWidth * xE, y2 + halfWidth * yE);
        shape.lineTo(x1 + halfWidth * xE, y1 + halfWidth * yE);
        shape.lineTo(x1 - halfWidth * xE, y1 - halfWidth * yE);

        var extruded = new THREE.ExtrudeGeometry(shape, {amount: -door.overallHeight ? -door.overallHeight : -2135});
        var darkMaterial = new THREE.MeshLambertMaterial({
            color: 0xffdddd,
            transparent: true,
            opacity: 0.7
        });

        var mesh = new THREE.Mesh(extruded, darkMaterial);

        door.__mesh = mesh;
        mesh.rotation.x = Math.PI / 2;

        this.scene.add(mesh);
    };

    /**
     *
     * @param options
     */
    BimViewer3d.prototype.renderWall = function (wall) {
        var width = 200;

        if (wall.__properties && wall.__properties.Reference) {
            var reference = wall.__properties.Reference.split('_');

            if (reference.length >= 3) {
                width = Number(reference[1]);
            }
        }

        if (isNaN(width)) {
            width = 200;
        }

        geo = wall.getGeo();

        var shape = new THREE.Shape();

        // TODO Just assuming 2 points

        if (geo.points.length != 2) {
            return;
        }

        var x1 = geo.points[0].x;
        var y1 = geo.points[0].y;
        var x2 = geo.points[1].x;
        var y2 = geo.points[1].y;

        var norm = Math.sqrt(Math.pow(x2 - x1, 2) + Math.pow(y2 - y1, 2));
        var xE = (y2 - y1) / norm;
        var yE = (x1 - x2) / norm;
        var halfWidth = 0.5 * width;

        shape.moveTo(x1 - halfWidth * xE, y1 - halfWidth * yE);
        shape.lineTo(x2 - halfWidth * xE, y2 - halfWidth * yE);
        shape.lineTo(x2 + halfWidth * xE, y2 + halfWidth * yE);
        shape.lineTo(x1 + halfWidth * xE, y1 + halfWidth * yE);
        shape.lineTo(x1 - halfWidth * xE, y1 - halfWidth * yE);

        var extruded = new THREE.ExtrudeGeometry(shape, {amount: -2700});
        var concreteMaterial = new THREE.MeshLambertMaterial({
            color: 0xddddff,
            transparent: true,
            opacity: 0.4
        });
        //var concreteTexture = new THREE.ImageUtils.loadTexture('css/images/concrete-texture.jpg');
        //var concreteMaterial = new THREE.MeshBasicMaterial({map: concreteTexture});

        var mesh = new THREE.Mesh(extruded, concreteMaterial);

        wall.__mesh = mesh;

        mesh.rotation.x = Math.PI / 2;

        this.scene.add(mesh);
    };

    /**
     *
     * @param options
     */
    BimViewer3d.prototype.setOptions = function (options) {
        if (!this.floor) {
            return;
        }

        // TODO Retrofitq

        // for (var n in this.floor.__spaces) {
        //     this.floor.__spaces[n].__mesh.visible = options.showSpaces ? true : false;
        // }
        // for (var n in this.floor.__walls) {
        //     this.floor.__walls[n].__mesh.visible = options.showWalls ? true : false;
        // }
        // for (var n in this.floor.__doors) {
        //     this.floor.__doors[n].__mesh.visible = options.showDoors ? true : false;
        // }
    };

    /**
     *
     * @constructor
     */
    function NavigationPathRenderer() {
        /**
         *
         * @param editor
         * @returns {NavigationPathRenderer}
         */
        NavigationPathRenderer.prototype.initialize = function (editor) {
            editor.addRenderer(this);

            this.options = {
                colors: {
                    pathColor: "#FF0000",
                    traversedColor: "#006400"
                }
            };

            return this;
        };

        /**
         *
         * @param event
         * @param navigator
         */
        NavigationPathRenderer.prototype.setOptions = function (options) {
            if (options.colors) {
                this.options.colors.pathColor = '#FF0000';
                options.colors.pathColor ? options.colors.pathColor : this.options.colors.pathColor;
                this.options.colors.traversedColor = '#006400';
                options.colors.traversedColor ? options.colors.traversedColor : this.options.colors.traversedColor;
            }
        };

        NavigationPathRenderer.prototype.render = function () {
            if (!this.parent) {
                return;
            }

            // if (this.group) {
            //     this.group.clear();
            // } else {
            this.group = this.parent.group();
        };

        /**
         *
         * @param event
         * @param navigator
         */
        NavigationPathRenderer.prototype.onNavigationEvent = function (event, navigator) {
            this.render();

            if (!this.group) {
                console.log('NavigationPathRenderer not fully rendered. Add timeout.');

                return;
            }

            if (event == 'routingStarted') {
                this.group.clear();

                var startBox = navigator.startSpace.getGeo().getBoundingBox();

                this.startCircle = this.group.circle(400).fill(this.options.colors.pathColor);
                this.startCircleBorder = this.group.circle(800).fill(this.options.colors.pathColor).opacity(0.2);

                this.startCircle.move(startBox.xCenter - 200, startBox.yCenter - 200);
                this.startCircleBorder.move(startBox.xCenter - 400, startBox.yCenter - 400);

                var endBox = navigator.destinationSpace.getGeo().getBoundingBox();

                this.destinationCircle = this.group.circle(400).fill(this.options.colors.pathColor);
                this.destinationCircleBorder = this.group.circle(800).fill(this.options.colors.pathColor);

                this.destinationCircle.move(endBox.xCenter - 200, endBox.yCenter - 200);
                this.destinationCircleBorder.move(endBox.xCenter - 400, endBox.yCenter - 400).opacity(0.2);
            }
            else if (event == 'pathFound') {
                this.points = [];
                this.visitedPoints = [];
                this.wayPoints = {};

                for (var n = 0; n < navigator.shortestRoute.steps.length; ++n) {
                    console.log('n = ', n);

                    var startBox;
                    var endBox = navigator.shortestRoute.steps[n].end.getGeo().getBoundingBox();

                    if (navigator.shortestRoute.steps[n].start.type == 'IFCSPACE' && n != 0) {
                        // Line starts at previous start

                        startBox = navigator.shortestRoute.steps[n - 1].start.getGeo().getBoundingBox();
                    } else if (navigator.shortestRoute.steps[n].end.type == 'IFCSPACE' && n != navigator.shortestRoute.steps.length - 1) {
                        // Skip intermediate spaces

                        continue;
                    } else {
                        startBox = navigator.shortestRoute.steps[n].start.getGeo().getBoundingBox();
                    }

                    if (n == 0) {
                        this.points.push([startBox.xCenter, startBox.yCenter]);
                        this.visitedPoints.push([startBox.xCenter, startBox.yCenter]);
                    }

                    this.wayPoints[navigator.shortestRoute.steps[n].end.id] = [endBox.xCenter, endBox.yCenter];
                    this.points.push([endBox.xCenter, endBox.yCenter]);
                }

                console.log('Points ', this.points);

                this.routePolyline = this.group.polyline(this.points).attr({
                    stroke: this.options.colors.pathColor,
                    'stroke-width': 50,
                    fill: 'none'
                });
                this.visitedRoutePolyline = this.group.polyline(this.visitedPoints).attr({
                    stroke: this.options.colors.traversedColor,
                    'stroke-width': 80,
                    fill: 'none'
                });
            }
            else if (event == 'noPathFound') {
            }
            else if (event == 'navigationStarted') {
                console.log('Circle', this.startCircle);
                console.log('Options', this.options);

                this.startCircle.attr({fill: this.options.colors.traversedColor});
                this.startCircleBorder.attr({fill: this.options.colors.traversedColor});
            }
            else if (event == 'spaceStep') {
            }
            else if (event == 'doorStep') {
                this.visitedPoints.push(this.wayPoints[navigator.shortestRoute.steps[navigator.step].end.id]);
                this.visitedRoutePolyline.animate(3000).plot(this.visitedPoints);
            }
            else if (event == 'destinationReached') {
                this.visitedPoints.push(this.wayPoints[navigator.shortestRoute.steps[navigator.step].end.id]);
                this.visitedRoutePolyline.animate(3000).plot(this.visitedPoints);
                this.destinationCircle.animate(5000).attr({fill: this.options.colors.traversedColor});
                this.destinationCircleBorder.animate(5000).attr({fill: this.options.colors.traversedColor});
            }
        };
    };

    function NavigationAnimator3d() {
    };

    /**
     *
     * @param editor
     * @returns {NavigationAnimator3d}
     */
    NavigationAnimator3d.prototype.initialize = function (bimViewer3d) {
        this.bimViewer3d = bimViewer3d;
        this.TRANSITION_TIME = 2000;
        this.OBSERVE_HEIGHT = 8000;
        this.EYES_HEIGHT = 1600;
        this.PATH_HEIGHT = 1600;

        this.options = {
            colors: {
                pathColor: "#FF0000",
                traversedColor: "#00FF00"
            }
        };

        return this;
    };

    /**
     *
     * @param event
     * @param navigator
     */
    NavigationAnimator3d.prototype.setOptions = function (options) {
        if (options.colors) {
            this.options.colors.pathColor = options.colors.pathColor ? options.colors.pathColor : this.options.colors.pathColor;
            this.options.colors.traversedColor = options.colors.traversedColor ? options.colors.traversedColor : this.options.colors.traversedColor;
        }
    };

    /**
     *
     * @param event
     * @param navigator
     */
    NavigationAnimator3d.prototype.onNavigationEvent = function (event, navigator) {
        if (event == 'routingStarted') {
            var startBox = navigator.startSpace.getGeo().getBoundingBox();
            var endBox = navigator.destinationSpace.getGeo().getBoundingBox();
            var geometry = new THREE.SphereGeometry(100, 32, 32);
            var material = new THREE.MeshLambertMaterial({color: this.options.colors.pathColor});

            this.startPoint = new THREE.Mesh(geometry, material);
            this.endPoint = new THREE.Mesh(geometry, material);

            this.startPoint.position.set(startBox.xCenter, this.PATH_HEIGHT, startBox.yCenter);
            this.bimViewer3d.scene.add(this.startPoint);
            this.endPoint.position.set(endBox.xCenter, this.PATH_HEIGHT, endBox.yCenter);
            this.bimViewer3d.scene.add(this.endPoint);
        }
        else if (event == 'pathFound') {
            this.lines = {};

            for (var n = 0; n < navigator.shortestRoute.steps.length; ++n) {
                var startGeo;
                var endGeo = navigator.shortestRoute.steps[n].end.getGeo();
                var endBox = endGeo.getBoundingBox();

                if (navigator.shortestRoute.steps[n].start.type == 'IFCSPACE' && n != 0) {
                    // Line starts at previous start

                    startGeo = navigator.shortestRoute.steps[n - 1].start.getGeo();
                } else if (navigator.shortestRoute.steps[n].end.type == 'IFCSPACE' && n != navigator.shortestRoute.steps.length - 1) {
                    // Skip intermediate spaces

                    continue;
                } else {
                    startGeo = navigator.shortestRoute.steps[n].start.getGeo();
                }

                var startBox = startGeo.getBoundingBox();
                var lineGeometry = new THREE.Geometry();
                var vertices = lineGeometry.vertices;

                vertices.push(new THREE.Vector3(startBox.xCenter, this.PATH_HEIGHT, startBox.yCenter), new THREE.Vector3(endBox.xCenter, this.PATH_HEIGHT, endBox.yCenter));

                lineGeometry.computeLineDistances();

                var lineMaterial = new THREE.LineBasicMaterial({color: this.options.colors.pathColor, linewidth: 5});
                var line = new THREE.Line(lineGeometry, lineMaterial);

                this.bimViewer3d.scene.add(line);

                this.lines[navigator.shortestRoute.steps[n].id] = line;
            }
        }
        else if (event == 'noPathFound') {
        }
        else if (event == 'navigationStarted') {
        }
        else if (event == 'spaceStep') {
            var startBox = navigator.shortestRoute.steps[navigator.step].start.getGeo().getBoundingBox();
            var endBox;

            if (navigator.step == navigator.shortestRoute.steps.length - 1) {
                endBox = navigator.shortestRoute.steps[navigator.step].end.getGeo().getBoundingBox();
            } else {
                endBox = navigator.shortestRoute.steps[navigator.step + 1].end.getGeo().getBoundingBox();
            }

            var position = {
                xCamera: this.bimViewer3d.camera.position.x,
                yCamera: this.bimViewer3d.camera.position.y,
                zCamera: this.bimViewer3d.camera.position.z,
                xLookAt: this.bimViewer3d.controls.center.x,
                yLookAt: this.bimViewer3d.controls.center.y,
                zLookAt: this.bimViewer3d.controls.center.z
            };

            // Animate move to middle of the room

            new TWEEN.Tween(position).to({
                xCamera: startBox.xCenter,
                yCamera: this.OBSERVE_HEIGHT,
                zCamera: startBox.yCenter,
                xLookAt: endBox.xCenter,
                yLookAt: this.EYES_HEIGHT,
                zLookAt: endBox.yCenter
            }, this.TRANSITION_TIME)
                .easing(TWEEN.Easing.Sinusoidal.In).onUpdate(function () {

                this.bimViewer3d.camera.position.set(position.xCamera,
                    position.yCamera,
                    position.zCamera);
                this.bimViewer3d.controls.center.set(position.xLookAt,
                    position.yLookAt,
                    position.zLookAt);
                this.bimViewer3d.renderCameraReferencePoint();
            }.bind(this)).start();
        }
        else if (event == 'doorStep') {
            var startBox = navigator.shortestRoute.steps[navigator.step].start.getGeo().getBoundingBox();
            var endBox = navigator.shortestRoute.steps[navigator.step].end.getGeo().getBoundingBox();
            var position = {
                xCamera: this.bimViewer3d.camera.position.x,
                yCamera: this.bimViewer3d.camera.position.y,
                zCamera: this.bimViewer3d.camera.position.z,
                xLookAt: this.bimViewer3d.controls.center.x,
                yLookAt: this.bimViewer3d.controls.center.y,
                zLookAt: this.bimViewer3d.controls.center.z
            };

            // Animate move to middle of the room

            new TWEEN.Tween(position).to({
                xCamera: startBox.xCenter,
                yCamera: this.OBSERVE_HEIGHT,
                zCamera: startBox.yCenter,
                xLookAt: endBox.xCenter,
                yLookAt: this.EYES_HEIGHT,
                zLookAt: endBox.yCenter
            }, this.TRANSITION_TIME)
                .easing(TWEEN.Easing.Sinusoidal.In).onUpdate(function () {

                this.bimViewer3d.camera.position.set(position.xCamera,
                    position.yCamera,
                    position.zCamera);
                this.bimViewer3d.controls.center.set(position.xLookAt,
                    position.yLookAt,
                    position.zLookAt);
                this.bimViewer3d.renderCameraReferencePoint();
            }.bind(this)).start();
        }
        else if (event == 'destinationReached') {
        }
    };
})
();

